//This version of CustomThread is very similar to the previous.  The only change is that
//a datafield isSleeping keeps track of if the thread is sleeping or not.

public class CustomThread2 extends Thread
{
   //------------------------------------------------------------------------------
   //Data fields
   //
   //threadNumber - Simply the number of the thread.  Not used in this application.
   //isSleeping - true when the thread is sleeping, false otherwise.
   //------------------------------------------------------------------------------
   
   public int threadNumber;
   public boolean isSleeping;
   
   //------------------------------------------------------------------------------
   //The constructor.
   //------------------------------------------------------------------------------
   
   public CustomThread2(int number)
   {
      threadNumber = number;
      isSleeping = true;
   }

   //------------------------------------------------------------------------------
   //The run method.  This method will output a "Working" message, then output a 
   //"Sleeping" message.  This goes on forever. Note that the isSleeping data field
   //is update throughout.
   //------------------------------------------------------------------------------

   public void run()
   {
      while(true)
      {
         //output message
         System.out.println("Thread #" + threadNumber + ": Working");
         
         //Try to sleep for a random amount of time.  Unfortunately, this has
         //to be done inside a try statement which makes this code look quite
         //ugly.
         
         int delay = (int)(Math.random() * 5000);  //delay of 0 to 5 seconds
         try 
         {
            isSleeping = true;
            System.out.println("Thread #" + threadNumber + ": Sleeping for " + delay);
            Thread.sleep(delay);
            isSleeping = false;
         }
         catch (InterruptedException e) 
         {
            break;
         }
      }
   }     
}