//This type of thread monitors 5 threads of type CustomThread2.  If all five are sleeping, 
//it will output a message stating that all five are sleeping.

//Note: This thread can miss occurences of all five threads sleeping if it doesn't get CPU
//time during that period.  

public class MonitorThread extends Thread
{
   //------------------------------------------------------------------------------
   //Data fields
   //
   //threadNumber - Simply the number of the thread.  Not used in this application.
   //ct1 to ct5 - The threads that will be monitored.
   //------------------------------------------------------------------------------
   
   public int threadNumber;
   public CustomThread2 ct1;
   public CustomThread2 ct2;
   public CustomThread2 ct3;
   public CustomThread2 ct4;
   public CustomThread2 ct5;
   
   //------------------------------------------------------------------------------
   //The constructor.
   //------------------------------------------------------------------------------
   
   public MonitorThread(int number, CustomThread2 t1, CustomThread2 t2, CustomThread2 t3, CustomThread2 t4, CustomThread2 t5)
   {
      threadNumber = number;
      ct1 = t1;
      ct2 = t2;
      ct3 = t3;
      ct4 = t4;
      ct5 = t5;
   }

   //------------------------------------------------------------------------------
   //The run method.  This method will continuously check if the five Custom Threads
   //are sleeping and output a message when all of them are asleep.  This test only 
   //occurs every 100 milliseconds or so.  Therefore, some occurences of all 5 threads
   //sleeping might be missed.
   //------------------------------------------------------------------------------

   public void run()
   {
      while(true)
      {

         if(ct1.isSleeping == true && ct2.isSleeping == true && ct3.isSleeping == true && ct4.isSleeping == true && ct5.isSleeping == true)
         {
            System.out.println("ALL FIVE ARE SLEEPING!!!");
         }
         int delay = 100;  //sleep for 1/10th of a second
         try 
         {  
            Thread.sleep(delay);
         }
         catch (InterruptedException e) 
         {
            break;
         }
      }
   }     
}